//
//  Copyright (C) 2004-2006  Autodesk, Inc.
//
//  This library is free software; you can redistribute it and/or
//  modify it under the terms of version 2.1 of the GNU Lesser
//  General Public License as published by the Free Software Foundation.
//
//  This library is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
//  Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public
//  License along with this library; if not, write to the Free Software
//  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//
#include "Foundation.h"
#include <locale.h>
#include "SetLocale.h"


MgSetLocale::MgSetLocale(int category, const char * locale) :
    m_category(category)
{
    m_strOldLocale = ::setlocale(m_category, NULL);
    m_strNewLocale = locale;
    if (m_strOldLocale != locale)
        ::setlocale(m_category, locale);
}


MgSetLocale::~MgSetLocale()
{
    if (m_strOldLocale != m_strNewLocale)
        ::setlocale(m_category, m_strOldLocale.c_str());
}
